//
// Copyright (c) Microsoft Corporation.  All rights reserved.
//
//
// Use of this source code is subject to the terms of the Microsoft end-user
// license agreement (EULA) under which you licensed this SOFTWARE PRODUCT.
// If you did not accept the terms of the EULA, you are not authorized to use
// this source code. For a copy of the EULA, please see the LICENSE.RTF on your
// install media.
//

#pragma warning( disable: 4049 )  /* more than 64k source lines */

/* this ALWAYS GENERATED file contains the definitions for the interfaces */


 /* File created by MIDL compiler version 5.03.0286 */
/* at Wed Sep 06 20:58:14 2006
 */
/* Compiler settings for .\dvdcss.idl:
    Oicf (OptLev=i2), W1, Zp8, env=Win32 (32b run), ms_ext, c_ext
    error checks: allocation ref bounds_check enum stub_data 
    VC __declspec() decoration level: 
         __declspec(uuid()), __declspec(selectany), __declspec(novtable)
         DECLSPEC_UUID(), MIDL_INTERFACE()
*/
//@@MIDL_FILE_HEADING(  )


/* verify that the <rpcndr.h> version is high enough to compile this file*/
#ifndef __REQUIRED_RPCNDR_H_VERSION__
#define __REQUIRED_RPCNDR_H_VERSION__ 440
#endif

#include "rpc.h"
#include "rpcndr.h"

#ifndef __RPCNDR_H_VERSION__
#error this stub requires an updated version of <rpcndr.h>
#endif // __RPCNDR_H_VERSION__

#ifndef COM_NO_WINDOWS_H
#include "windows.h"
#include "ole2.h"
#endif /*COM_NO_WINDOWS_H*/

#ifndef __dvdcss_h__
#define __dvdcss_h__

/* Forward Declarations */ 

#ifndef __IDVDDecoderCSS_FWD_DEFINED__
#define __IDVDDecoderCSS_FWD_DEFINED__
typedef interface IDVDDecoderCSS IDVDDecoderCSS;
#endif 	/* __IDVDDecoderCSS_FWD_DEFINED__ */


/* header files for imported files */
#include "unknwn.h"
#include "dvdcom.h"

#ifdef __cplusplus
extern "C"{
#endif 

void __RPC_FAR * __RPC_USER MIDL_user_allocate(size_t);
void __RPC_USER MIDL_user_free( void __RPC_FAR * ); 

#ifndef __IDVDDecoderCSS_INTERFACE_DEFINED__
#define __IDVDDecoderCSS_INTERFACE_DEFINED__

/* interface IDVDDecoderCSS */
/* [unique][helpstring][uuid][object] */ 


EXTERN_C const IID IID_IDVDDecoderCSS;

#if defined(__cplusplus) && !defined(CINTERFACE)
    
    MIDL_INTERFACE("AD3452B0-9FC8-11d4-84DD-00C04F68EB0F")
    IDVDDecoderCSS : public IUnknown
    {
    public:
        virtual HRESULT STDMETHODCALLTYPE SetSectorLength( 
            UINT dwLength) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE NewDisk( void) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE InitiateAuthentication( void) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetChallenge( 
            CSS_CHALLENGE __RPC_FAR *pChallenge) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE SendDriveResponseKey( 
            CSS_KEY __RPC_FAR *pKey) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE SendDriveChallenge( 
            CSS_CHALLENGE __RPC_FAR *pChallenge) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetResponseKey( 
            CSS_KEY __RPC_FAR *pKey) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE ResetAuthentication( void) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE SendScrambledDiskKeyData( 
            CSS_SDKS __RPC_FAR *pSDKS) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE SendTitleKey( 
            CSS_KEY __RPC_FAR *pKey) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE EnableDescrambler( void) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE BypassDescrambler( void) = 0;
        
    };
    
#else 	/* C style interface */

    typedef struct IDVDDecoderCSSVtbl
    {
        BEGIN_INTERFACE
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *QueryInterface )( 
            IDVDDecoderCSS __RPC_FAR * This,
            /* [in] */ REFIID riid,
            /* [iid_is][out] */ void __RPC_FAR *__RPC_FAR *ppvObject);
        
        ULONG ( STDMETHODCALLTYPE __RPC_FAR *AddRef )( 
            IDVDDecoderCSS __RPC_FAR * This);
        
        ULONG ( STDMETHODCALLTYPE __RPC_FAR *Release )( 
            IDVDDecoderCSS __RPC_FAR * This);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetSectorLength )( 
            IDVDDecoderCSS __RPC_FAR * This,
            UINT dwLength);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *NewDisk )( 
            IDVDDecoderCSS __RPC_FAR * This);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *InitiateAuthentication )( 
            IDVDDecoderCSS __RPC_FAR * This);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetChallenge )( 
            IDVDDecoderCSS __RPC_FAR * This,
            CSS_CHALLENGE __RPC_FAR *pChallenge);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SendDriveResponseKey )( 
            IDVDDecoderCSS __RPC_FAR * This,
            CSS_KEY __RPC_FAR *pKey);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SendDriveChallenge )( 
            IDVDDecoderCSS __RPC_FAR * This,
            CSS_CHALLENGE __RPC_FAR *pChallenge);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetResponseKey )( 
            IDVDDecoderCSS __RPC_FAR * This,
            CSS_KEY __RPC_FAR *pKey);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *ResetAuthentication )( 
            IDVDDecoderCSS __RPC_FAR * This);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SendScrambledDiskKeyData )( 
            IDVDDecoderCSS __RPC_FAR * This,
            CSS_SDKS __RPC_FAR *pSDKS);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SendTitleKey )( 
            IDVDDecoderCSS __RPC_FAR * This,
            CSS_KEY __RPC_FAR *pKey);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *EnableDescrambler )( 
            IDVDDecoderCSS __RPC_FAR * This);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *BypassDescrambler )( 
            IDVDDecoderCSS __RPC_FAR * This);
        
        END_INTERFACE
    } IDVDDecoderCSSVtbl;

    interface IDVDDecoderCSS
    {
        CONST_VTBL struct IDVDDecoderCSSVtbl __RPC_FAR *lpVtbl;
    };

    

#ifdef COBJMACROS


#define IDVDDecoderCSS_QueryInterface(This,riid,ppvObject)	\
    (This)->lpVtbl -> QueryInterface(This,riid,ppvObject)

#define IDVDDecoderCSS_AddRef(This)	\
    (This)->lpVtbl -> AddRef(This)

#define IDVDDecoderCSS_Release(This)	\
    (This)->lpVtbl -> Release(This)


#define IDVDDecoderCSS_SetSectorLength(This,dwLength)	\
    (This)->lpVtbl -> SetSectorLength(This,dwLength)

#define IDVDDecoderCSS_NewDisk(This)	\
    (This)->lpVtbl -> NewDisk(This)

#define IDVDDecoderCSS_InitiateAuthentication(This)	\
    (This)->lpVtbl -> InitiateAuthentication(This)

#define IDVDDecoderCSS_GetChallenge(This,pChallenge)	\
    (This)->lpVtbl -> GetChallenge(This,pChallenge)

#define IDVDDecoderCSS_SendDriveResponseKey(This,pKey)	\
    (This)->lpVtbl -> SendDriveResponseKey(This,pKey)

#define IDVDDecoderCSS_SendDriveChallenge(This,pChallenge)	\
    (This)->lpVtbl -> SendDriveChallenge(This,pChallenge)

#define IDVDDecoderCSS_GetResponseKey(This,pKey)	\
    (This)->lpVtbl -> GetResponseKey(This,pKey)

#define IDVDDecoderCSS_ResetAuthentication(This)	\
    (This)->lpVtbl -> ResetAuthentication(This)

#define IDVDDecoderCSS_SendScrambledDiskKeyData(This,pSDKS)	\
    (This)->lpVtbl -> SendScrambledDiskKeyData(This,pSDKS)

#define IDVDDecoderCSS_SendTitleKey(This,pKey)	\
    (This)->lpVtbl -> SendTitleKey(This,pKey)

#define IDVDDecoderCSS_EnableDescrambler(This)	\
    (This)->lpVtbl -> EnableDescrambler(This)

#define IDVDDecoderCSS_BypassDescrambler(This)	\
    (This)->lpVtbl -> BypassDescrambler(This)

#endif /* COBJMACROS */


#endif 	/* C style interface */



HRESULT STDMETHODCALLTYPE IDVDDecoderCSS_SetSectorLength_Proxy( 
    IDVDDecoderCSS __RPC_FAR * This,
    UINT dwLength);


void __RPC_STUB IDVDDecoderCSS_SetSectorLength_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDDecoderCSS_NewDisk_Proxy( 
    IDVDDecoderCSS __RPC_FAR * This);


void __RPC_STUB IDVDDecoderCSS_NewDisk_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDDecoderCSS_InitiateAuthentication_Proxy( 
    IDVDDecoderCSS __RPC_FAR * This);


void __RPC_STUB IDVDDecoderCSS_InitiateAuthentication_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDDecoderCSS_GetChallenge_Proxy( 
    IDVDDecoderCSS __RPC_FAR * This,
    CSS_CHALLENGE __RPC_FAR *pChallenge);


void __RPC_STUB IDVDDecoderCSS_GetChallenge_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDDecoderCSS_SendDriveResponseKey_Proxy( 
    IDVDDecoderCSS __RPC_FAR * This,
    CSS_KEY __RPC_FAR *pKey);


void __RPC_STUB IDVDDecoderCSS_SendDriveResponseKey_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDDecoderCSS_SendDriveChallenge_Proxy( 
    IDVDDecoderCSS __RPC_FAR * This,
    CSS_CHALLENGE __RPC_FAR *pChallenge);


void __RPC_STUB IDVDDecoderCSS_SendDriveChallenge_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDDecoderCSS_GetResponseKey_Proxy( 
    IDVDDecoderCSS __RPC_FAR * This,
    CSS_KEY __RPC_FAR *pKey);


void __RPC_STUB IDVDDecoderCSS_GetResponseKey_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDDecoderCSS_ResetAuthentication_Proxy( 
    IDVDDecoderCSS __RPC_FAR * This);


void __RPC_STUB IDVDDecoderCSS_ResetAuthentication_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDDecoderCSS_SendScrambledDiskKeyData_Proxy( 
    IDVDDecoderCSS __RPC_FAR * This,
    CSS_SDKS __RPC_FAR *pSDKS);


void __RPC_STUB IDVDDecoderCSS_SendScrambledDiskKeyData_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDDecoderCSS_SendTitleKey_Proxy( 
    IDVDDecoderCSS __RPC_FAR * This,
    CSS_KEY __RPC_FAR *pKey);


void __RPC_STUB IDVDDecoderCSS_SendTitleKey_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDDecoderCSS_EnableDescrambler_Proxy( 
    IDVDDecoderCSS __RPC_FAR * This);


void __RPC_STUB IDVDDecoderCSS_EnableDescrambler_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDDecoderCSS_BypassDescrambler_Proxy( 
    IDVDDecoderCSS __RPC_FAR * This);


void __RPC_STUB IDVDDecoderCSS_BypassDescrambler_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);



#endif 	/* __IDVDDecoderCSS_INTERFACE_DEFINED__ */


/* Additional Prototypes for ALL interfaces */

/* end of Additional Prototypes */

#ifdef __cplusplus
}
#endif

#endif


