//
// Copyright (c) Microsoft Corporation.  All rights reserved.
//
//
// Use of this source code is subject to the terms of the Microsoft end-user
// license agreement (EULA) under which you licensed this SOFTWARE PRODUCT.
// If you did not accept the terms of the EULA, you are not authorized to use
// this source code. For a copy of the EULA, please see the LICENSE.RTF on your
// install media.
//

#pragma warning( disable: 4049 )  /* more than 64k source lines */

/* this ALWAYS GENERATED file contains the definitions for the interfaces */


 /* File created by MIDL compiler version 5.03.0286 */
/* at Wed Sep 06 20:58:12 2006
 */
/* Compiler settings for .\dvddrvr.idl:
    Oicf (OptLev=i2), W1, Zp8, env=Win32 (32b run), ms_ext, c_ext
    error checks: allocation ref bounds_check enum stub_data 
    VC __declspec() decoration level: 
         __declspec(uuid()), __declspec(selectany), __declspec(novtable)
         DECLSPEC_UUID(), MIDL_INTERFACE()
*/
//@@MIDL_FILE_HEADING(  )


/* verify that the <rpcndr.h> version is high enough to compile this file*/
#ifndef __REQUIRED_RPCNDR_H_VERSION__
#define __REQUIRED_RPCNDR_H_VERSION__ 440
#endif

#include "rpc.h"
#include "rpcndr.h"

#ifndef __RPCNDR_H_VERSION__
#error this stub requires an updated version of <rpcndr.h>
#endif // __RPCNDR_H_VERSION__

#ifndef COM_NO_WINDOWS_H
#include "windows.h"
#include "ole2.h"
#endif /*COM_NO_WINDOWS_H*/

#ifndef __dvddrvr_h__
#define __dvddrvr_h__

/* Forward Declarations */ 

#ifndef __IDMAChannel_FWD_DEFINED__
#define __IDMAChannel_FWD_DEFINED__
typedef interface IDMAChannel IDMAChannel;
#endif 	/* __IDMAChannel_FWD_DEFINED__ */


#ifndef __IDMAChannel2_FWD_DEFINED__
#define __IDMAChannel2_FWD_DEFINED__
typedef interface IDMAChannel2 IDMAChannel2;
#endif 	/* __IDMAChannel2_FWD_DEFINED__ */


#ifndef __IDataPort_FWD_DEFINED__
#define __IDataPort_FWD_DEFINED__
typedef interface IDataPort IDataPort;
#endif 	/* __IDataPort_FWD_DEFINED__ */


#ifndef __IDataPortCollection_FWD_DEFINED__
#define __IDataPortCollection_FWD_DEFINED__
typedef interface IDataPortCollection IDataPortCollection;
#endif 	/* __IDataPortCollection_FWD_DEFINED__ */


#ifndef __IMediaDriver_FWD_DEFINED__
#define __IMediaDriver_FWD_DEFINED__
typedef interface IMediaDriver IMediaDriver;
#endif 	/* __IMediaDriver_FWD_DEFINED__ */


#ifndef __IBitstreamProcessor_FWD_DEFINED__
#define __IBitstreamProcessor_FWD_DEFINED__
typedef interface IBitstreamProcessor IBitstreamProcessor;
#endif 	/* __IBitstreamProcessor_FWD_DEFINED__ */


#ifndef __IBitstreamProcessor2_FWD_DEFINED__
#define __IBitstreamProcessor2_FWD_DEFINED__
typedef interface IBitstreamProcessor2 IBitstreamProcessor2;
#endif 	/* __IBitstreamProcessor2_FWD_DEFINED__ */


#ifndef __IDVDRenderer_FWD_DEFINED__
#define __IDVDRenderer_FWD_DEFINED__
typedef interface IDVDRenderer IDVDRenderer;
#endif 	/* __IDVDRenderer_FWD_DEFINED__ */


#ifndef __DataPort_FWD_DEFINED__
#define __DataPort_FWD_DEFINED__

#ifdef __cplusplus
typedef class DataPort DataPort;
#else
typedef struct DataPort DataPort;
#endif /* __cplusplus */

#endif 	/* __DataPort_FWD_DEFINED__ */


#ifndef __MediaDriver_FWD_DEFINED__
#define __MediaDriver_FWD_DEFINED__

#ifdef __cplusplus
typedef class MediaDriver MediaDriver;
#else
typedef struct MediaDriver MediaDriver;
#endif /* __cplusplus */

#endif 	/* __MediaDriver_FWD_DEFINED__ */


/* header files for imported files */
#include "unknwn.h"

#ifdef __cplusplus
extern "C"{
#endif 

void __RPC_FAR * __RPC_USER MIDL_user_allocate(size_t);
void __RPC_USER MIDL_user_free( void __RPC_FAR * ); 

/* interface __MIDL_itf_dvddrvr_0000 */
/* [local] */ 

typedef void ( __RPC_FAR *PNOTIFICATION_CALLBACK )( 
    void __RPC_FAR *pArg);

typedef LARGE_INTEGER PHYSICAL_ADDRESS;

#define MAX_PORT_LABEL_LENGTH 256


extern RPC_IF_HANDLE __MIDL_itf_dvddrvr_0000_v0_0_c_ifspec;
extern RPC_IF_HANDLE __MIDL_itf_dvddrvr_0000_v0_0_s_ifspec;

#ifndef __IDMAChannel_INTERFACE_DEFINED__
#define __IDMAChannel_INTERFACE_DEFINED__

/* interface IDMAChannel */
/* [unique][helpstring][local][uuid][object] */ 


EXTERN_C const IID IID_IDMAChannel;

#if defined(__cplusplus) && !defined(CINTERFACE)
    
    MIDL_INTERFACE("99C99C6C-43E8-11d4-84C8-00C04F68EB0F")
    IDMAChannel : public IUnknown
    {
    public:
        virtual HRESULT STDMETHODCALLTYPE GetLabel( 
            GUID __RPC_FAR *puuidLabelSystem,
            WCHAR __RPC_FAR *labelBuf,
            DWORD labelBufSz) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetMaxOutstandingTransfers( 
            DWORD __RPC_FAR *pdwTransfers,
            DWORD __RPC_FAR *pdwMaxSize) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetPendingTransfersCount( 
            DWORD __RPC_FAR *pdwPending) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE SetDataNotificationThreshold( 
            DWORD dwPendingThreshold) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE SetThresholdCallback( 
            PNOTIFICATION_CALLBACK pProc,
            DWORD arg) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE RequestTransfer( 
            PHYSICAL_ADDRESS physStart,
            DWORD dwSize,
            void __RPC_FAR *pva,
            DWORD __RPC_FAR *pdwPending) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE AbortAllTransfers( void) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE OnDiscontinuity( void) = 0;
        
    };
    
#else 	/* C style interface */

    typedef struct IDMAChannelVtbl
    {
        BEGIN_INTERFACE
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *QueryInterface )( 
            IDMAChannel __RPC_FAR * This,
            /* [in] */ REFIID riid,
            /* [iid_is][out] */ void __RPC_FAR *__RPC_FAR *ppvObject);
        
        ULONG ( STDMETHODCALLTYPE __RPC_FAR *AddRef )( 
            IDMAChannel __RPC_FAR * This);
        
        ULONG ( STDMETHODCALLTYPE __RPC_FAR *Release )( 
            IDMAChannel __RPC_FAR * This);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetLabel )( 
            IDMAChannel __RPC_FAR * This,
            GUID __RPC_FAR *puuidLabelSystem,
            WCHAR __RPC_FAR *labelBuf,
            DWORD labelBufSz);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetMaxOutstandingTransfers )( 
            IDMAChannel __RPC_FAR * This,
            DWORD __RPC_FAR *pdwTransfers,
            DWORD __RPC_FAR *pdwMaxSize);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetPendingTransfersCount )( 
            IDMAChannel __RPC_FAR * This,
            DWORD __RPC_FAR *pdwPending);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetDataNotificationThreshold )( 
            IDMAChannel __RPC_FAR * This,
            DWORD dwPendingThreshold);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetThresholdCallback )( 
            IDMAChannel __RPC_FAR * This,
            PNOTIFICATION_CALLBACK pProc,
            DWORD arg);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *RequestTransfer )( 
            IDMAChannel __RPC_FAR * This,
            PHYSICAL_ADDRESS physStart,
            DWORD dwSize,
            void __RPC_FAR *pva,
            DWORD __RPC_FAR *pdwPending);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *AbortAllTransfers )( 
            IDMAChannel __RPC_FAR * This);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *OnDiscontinuity )( 
            IDMAChannel __RPC_FAR * This);
        
        END_INTERFACE
    } IDMAChannelVtbl;

    interface IDMAChannel
    {
        CONST_VTBL struct IDMAChannelVtbl __RPC_FAR *lpVtbl;
    };

    

#ifdef COBJMACROS


#define IDMAChannel_QueryInterface(This,riid,ppvObject)	\
    (This)->lpVtbl -> QueryInterface(This,riid,ppvObject)

#define IDMAChannel_AddRef(This)	\
    (This)->lpVtbl -> AddRef(This)

#define IDMAChannel_Release(This)	\
    (This)->lpVtbl -> Release(This)


#define IDMAChannel_GetLabel(This,puuidLabelSystem,labelBuf,labelBufSz)	\
    (This)->lpVtbl -> GetLabel(This,puuidLabelSystem,labelBuf,labelBufSz)

#define IDMAChannel_GetMaxOutstandingTransfers(This,pdwTransfers,pdwMaxSize)	\
    (This)->lpVtbl -> GetMaxOutstandingTransfers(This,pdwTransfers,pdwMaxSize)

#define IDMAChannel_GetPendingTransfersCount(This,pdwPending)	\
    (This)->lpVtbl -> GetPendingTransfersCount(This,pdwPending)

#define IDMAChannel_SetDataNotificationThreshold(This,dwPendingThreshold)	\
    (This)->lpVtbl -> SetDataNotificationThreshold(This,dwPendingThreshold)

#define IDMAChannel_SetThresholdCallback(This,pProc,arg)	\
    (This)->lpVtbl -> SetThresholdCallback(This,pProc,arg)

#define IDMAChannel_RequestTransfer(This,physStart,dwSize,pva,pdwPending)	\
    (This)->lpVtbl -> RequestTransfer(This,physStart,dwSize,pva,pdwPending)

#define IDMAChannel_AbortAllTransfers(This)	\
    (This)->lpVtbl -> AbortAllTransfers(This)

#define IDMAChannel_OnDiscontinuity(This)	\
    (This)->lpVtbl -> OnDiscontinuity(This)

#endif /* COBJMACROS */


#endif 	/* C style interface */



HRESULT STDMETHODCALLTYPE IDMAChannel_GetLabel_Proxy( 
    IDMAChannel __RPC_FAR * This,
    GUID __RPC_FAR *puuidLabelSystem,
    WCHAR __RPC_FAR *labelBuf,
    DWORD labelBufSz);


void __RPC_STUB IDMAChannel_GetLabel_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDMAChannel_GetMaxOutstandingTransfers_Proxy( 
    IDMAChannel __RPC_FAR * This,
    DWORD __RPC_FAR *pdwTransfers,
    DWORD __RPC_FAR *pdwMaxSize);


void __RPC_STUB IDMAChannel_GetMaxOutstandingTransfers_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDMAChannel_GetPendingTransfersCount_Proxy( 
    IDMAChannel __RPC_FAR * This,
    DWORD __RPC_FAR *pdwPending);


void __RPC_STUB IDMAChannel_GetPendingTransfersCount_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDMAChannel_SetDataNotificationThreshold_Proxy( 
    IDMAChannel __RPC_FAR * This,
    DWORD dwPendingThreshold);


void __RPC_STUB IDMAChannel_SetDataNotificationThreshold_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDMAChannel_SetThresholdCallback_Proxy( 
    IDMAChannel __RPC_FAR * This,
    PNOTIFICATION_CALLBACK pProc,
    DWORD arg);


void __RPC_STUB IDMAChannel_SetThresholdCallback_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDMAChannel_RequestTransfer_Proxy( 
    IDMAChannel __RPC_FAR * This,
    PHYSICAL_ADDRESS physStart,
    DWORD dwSize,
    void __RPC_FAR *pva,
    DWORD __RPC_FAR *pdwPending);


void __RPC_STUB IDMAChannel_RequestTransfer_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDMAChannel_AbortAllTransfers_Proxy( 
    IDMAChannel __RPC_FAR * This);


void __RPC_STUB IDMAChannel_AbortAllTransfers_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDMAChannel_OnDiscontinuity_Proxy( 
    IDMAChannel __RPC_FAR * This);


void __RPC_STUB IDMAChannel_OnDiscontinuity_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);



#endif 	/* __IDMAChannel_INTERFACE_DEFINED__ */


#ifndef __IDMAChannel2_INTERFACE_DEFINED__
#define __IDMAChannel2_INTERFACE_DEFINED__

/* interface IDMAChannel2 */
/* [unique][helpstring][local][uuid][object] */ 


EXTERN_C const IID IID_IDMAChannel2;

#if defined(__cplusplus) && !defined(CINTERFACE)
    
    MIDL_INTERFACE("79342407-EE6F-462A-8116-94744118DAD5")
    IDMAChannel2 : public IDMAChannel
    {
    public:
        virtual HRESULT STDMETHODCALLTYPE RequestTransfer( 
            void __RPC_FAR *pVirtualAddress,
            DWORD dwTransferSize,
            DWORD __RPC_FAR *pdwPendingTransfers) = 0;
        
    };
    
#else 	/* C style interface */

    typedef struct IDMAChannel2Vtbl
    {
        BEGIN_INTERFACE
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *QueryInterface )( 
            IDMAChannel2 __RPC_FAR * This,
            /* [in] */ REFIID riid,
            /* [iid_is][out] */ void __RPC_FAR *__RPC_FAR *ppvObject);
        
        ULONG ( STDMETHODCALLTYPE __RPC_FAR *AddRef )( 
            IDMAChannel2 __RPC_FAR * This);
        
        ULONG ( STDMETHODCALLTYPE __RPC_FAR *Release )( 
            IDMAChannel2 __RPC_FAR * This);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetLabel )( 
            IDMAChannel2 __RPC_FAR * This,
            GUID __RPC_FAR *puuidLabelSystem,
            WCHAR __RPC_FAR *labelBuf,
            DWORD labelBufSz);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetMaxOutstandingTransfers )( 
            IDMAChannel2 __RPC_FAR * This,
            DWORD __RPC_FAR *pdwTransfers,
            DWORD __RPC_FAR *pdwMaxSize);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetPendingTransfersCount )( 
            IDMAChannel2 __RPC_FAR * This,
            DWORD __RPC_FAR *pdwPending);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetDataNotificationThreshold )( 
            IDMAChannel2 __RPC_FAR * This,
            DWORD dwPendingThreshold);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetThresholdCallback )( 
            IDMAChannel2 __RPC_FAR * This,
            PNOTIFICATION_CALLBACK pProc,
            DWORD arg);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *RequestTransfer )( 
            IDMAChannel2 __RPC_FAR * This,
            PHYSICAL_ADDRESS physStart,
            DWORD dwSize,
            void __RPC_FAR *pva,
            DWORD __RPC_FAR *pdwPending);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *AbortAllTransfers )( 
            IDMAChannel2 __RPC_FAR * This);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *OnDiscontinuity )( 
            IDMAChannel2 __RPC_FAR * This);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *RequestTransfer )( 
            IDMAChannel2 __RPC_FAR * This,
            void __RPC_FAR *pVirtualAddress,
            DWORD dwTransferSize,
            DWORD __RPC_FAR *pdwPendingTransfers);
        
        END_INTERFACE
    } IDMAChannel2Vtbl;

    interface IDMAChannel2
    {
        CONST_VTBL struct IDMAChannel2Vtbl __RPC_FAR *lpVtbl;
    };

    

#ifdef COBJMACROS


#define IDMAChannel2_QueryInterface(This,riid,ppvObject)	\
    (This)->lpVtbl -> QueryInterface(This,riid,ppvObject)

#define IDMAChannel2_AddRef(This)	\
    (This)->lpVtbl -> AddRef(This)

#define IDMAChannel2_Release(This)	\
    (This)->lpVtbl -> Release(This)


#define IDMAChannel2_GetLabel(This,puuidLabelSystem,labelBuf,labelBufSz)	\
    (This)->lpVtbl -> GetLabel(This,puuidLabelSystem,labelBuf,labelBufSz)

#define IDMAChannel2_GetMaxOutstandingTransfers(This,pdwTransfers,pdwMaxSize)	\
    (This)->lpVtbl -> GetMaxOutstandingTransfers(This,pdwTransfers,pdwMaxSize)

#define IDMAChannel2_GetPendingTransfersCount(This,pdwPending)	\
    (This)->lpVtbl -> GetPendingTransfersCount(This,pdwPending)

#define IDMAChannel2_SetDataNotificationThreshold(This,dwPendingThreshold)	\
    (This)->lpVtbl -> SetDataNotificationThreshold(This,dwPendingThreshold)

#define IDMAChannel2_SetThresholdCallback(This,pProc,arg)	\
    (This)->lpVtbl -> SetThresholdCallback(This,pProc,arg)

#define IDMAChannel2_RequestTransfer(This,physStart,dwSize,pva,pdwPending)	\
    (This)->lpVtbl -> RequestTransfer(This,physStart,dwSize,pva,pdwPending)

#define IDMAChannel2_AbortAllTransfers(This)	\
    (This)->lpVtbl -> AbortAllTransfers(This)

#define IDMAChannel2_OnDiscontinuity(This)	\
    (This)->lpVtbl -> OnDiscontinuity(This)


#define IDMAChannel2_RequestTransfer(This,pVirtualAddress,dwTransferSize,pdwPendingTransfers)	\
    (This)->lpVtbl -> RequestTransfer(This,pVirtualAddress,dwTransferSize,pdwPendingTransfers)

#endif /* COBJMACROS */


#endif 	/* C style interface */



HRESULT STDMETHODCALLTYPE IDMAChannel2_RequestTransfer_Proxy( 
    IDMAChannel2 __RPC_FAR * This,
    void __RPC_FAR *pVirtualAddress,
    DWORD dwTransferSize,
    DWORD __RPC_FAR *pdwPendingTransfers);


void __RPC_STUB IDMAChannel2_RequestTransfer_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);



#endif 	/* __IDMAChannel2_INTERFACE_DEFINED__ */


#ifndef __IDataPort_INTERFACE_DEFINED__
#define __IDataPort_INTERFACE_DEFINED__

/* interface IDataPort */
/* [unique][helpstring][local][uuid][object] */ 


EXTERN_C const IID IID_IDataPort;

#if defined(__cplusplus) && !defined(CINTERFACE)
    
    MIDL_INTERFACE("99C99C6D-43E8-11d4-84C8-00C04F68EB0F")
    IDataPort : public IUnknown
    {
    public:
        virtual HRESULT STDMETHODCALLTYPE AttachDMAChannel( 
            IDMAChannel2 __RPC_FAR *pDmaChannel2) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetLabel( 
            GUID __RPC_FAR *puuidLabelSystem,
            WCHAR __RPC_FAR *labelBuf,
            DWORD labelBufSz) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE SendData( 
            void __RPC_FAR *va,
            DWORD sz,
            HANDLE h,
            DWORD dwFlags) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE Flush( void) = 0;
        
    };
    
#else 	/* C style interface */

    typedef struct IDataPortVtbl
    {
        BEGIN_INTERFACE
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *QueryInterface )( 
            IDataPort __RPC_FAR * This,
            /* [in] */ REFIID riid,
            /* [iid_is][out] */ void __RPC_FAR *__RPC_FAR *ppvObject);
        
        ULONG ( STDMETHODCALLTYPE __RPC_FAR *AddRef )( 
            IDataPort __RPC_FAR * This);
        
        ULONG ( STDMETHODCALLTYPE __RPC_FAR *Release )( 
            IDataPort __RPC_FAR * This);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *AttachDMAChannel )( 
            IDataPort __RPC_FAR * This,
            IDMAChannel2 __RPC_FAR *pDmaChannel2);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetLabel )( 
            IDataPort __RPC_FAR * This,
            GUID __RPC_FAR *puuidLabelSystem,
            WCHAR __RPC_FAR *labelBuf,
            DWORD labelBufSz);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SendData )( 
            IDataPort __RPC_FAR * This,
            void __RPC_FAR *va,
            DWORD sz,
            HANDLE h,
            DWORD dwFlags);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Flush )( 
            IDataPort __RPC_FAR * This);
        
        END_INTERFACE
    } IDataPortVtbl;

    interface IDataPort
    {
        CONST_VTBL struct IDataPortVtbl __RPC_FAR *lpVtbl;
    };

    

#ifdef COBJMACROS


#define IDataPort_QueryInterface(This,riid,ppvObject)	\
    (This)->lpVtbl -> QueryInterface(This,riid,ppvObject)

#define IDataPort_AddRef(This)	\
    (This)->lpVtbl -> AddRef(This)

#define IDataPort_Release(This)	\
    (This)->lpVtbl -> Release(This)


#define IDataPort_AttachDMAChannel(This,pDmaChannel2)	\
    (This)->lpVtbl -> AttachDMAChannel(This,pDmaChannel2)

#define IDataPort_GetLabel(This,puuidLabelSystem,labelBuf,labelBufSz)	\
    (This)->lpVtbl -> GetLabel(This,puuidLabelSystem,labelBuf,labelBufSz)

#define IDataPort_SendData(This,va,sz,h,dwFlags)	\
    (This)->lpVtbl -> SendData(This,va,sz,h,dwFlags)

#define IDataPort_Flush(This)	\
    (This)->lpVtbl -> Flush(This)

#endif /* COBJMACROS */


#endif 	/* C style interface */



HRESULT STDMETHODCALLTYPE IDataPort_AttachDMAChannel_Proxy( 
    IDataPort __RPC_FAR * This,
    IDMAChannel2 __RPC_FAR *pDmaChannel2);


void __RPC_STUB IDataPort_AttachDMAChannel_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDataPort_GetLabel_Proxy( 
    IDataPort __RPC_FAR * This,
    GUID __RPC_FAR *puuidLabelSystem,
    WCHAR __RPC_FAR *labelBuf,
    DWORD labelBufSz);


void __RPC_STUB IDataPort_GetLabel_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDataPort_SendData_Proxy( 
    IDataPort __RPC_FAR * This,
    void __RPC_FAR *va,
    DWORD sz,
    HANDLE h,
    DWORD dwFlags);


void __RPC_STUB IDataPort_SendData_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDataPort_Flush_Proxy( 
    IDataPort __RPC_FAR * This);


void __RPC_STUB IDataPort_Flush_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);



#endif 	/* __IDataPort_INTERFACE_DEFINED__ */


#ifndef __IDataPortCollection_INTERFACE_DEFINED__
#define __IDataPortCollection_INTERFACE_DEFINED__

/* interface IDataPortCollection */
/* [unique][helpstring][local][uuid][object] */ 


EXTERN_C const IID IID_IDataPortCollection;

#if defined(__cplusplus) && !defined(CINTERFACE)
    
    MIDL_INTERFACE("99C99C74-43E8-11d4-84C8-00C04F68EB0F")
    IDataPortCollection : public IUnknown
    {
    public:
        virtual HRESULT STDMETHODCALLTYPE GetLabeledDataPort( 
            REFGUID guidLabelSystem,
            WCHAR __RPC_FAR *labelBuf,
            IDataPort __RPC_FAR *__RPC_FAR *ppDataPort) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetDataPortCount( 
            DWORD __RPC_FAR *pdwCount) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetDataPort( 
            DWORD index,
            IDataPort __RPC_FAR *__RPC_FAR *ppDataPort) = 0;
        
    };
    
#else 	/* C style interface */

    typedef struct IDataPortCollectionVtbl
    {
        BEGIN_INTERFACE
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *QueryInterface )( 
            IDataPortCollection __RPC_FAR * This,
            /* [in] */ REFIID riid,
            /* [iid_is][out] */ void __RPC_FAR *__RPC_FAR *ppvObject);
        
        ULONG ( STDMETHODCALLTYPE __RPC_FAR *AddRef )( 
            IDataPortCollection __RPC_FAR * This);
        
        ULONG ( STDMETHODCALLTYPE __RPC_FAR *Release )( 
            IDataPortCollection __RPC_FAR * This);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetLabeledDataPort )( 
            IDataPortCollection __RPC_FAR * This,
            REFGUID guidLabelSystem,
            WCHAR __RPC_FAR *labelBuf,
            IDataPort __RPC_FAR *__RPC_FAR *ppDataPort);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetDataPortCount )( 
            IDataPortCollection __RPC_FAR * This,
            DWORD __RPC_FAR *pdwCount);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetDataPort )( 
            IDataPortCollection __RPC_FAR * This,
            DWORD index,
            IDataPort __RPC_FAR *__RPC_FAR *ppDataPort);
        
        END_INTERFACE
    } IDataPortCollectionVtbl;

    interface IDataPortCollection
    {
        CONST_VTBL struct IDataPortCollectionVtbl __RPC_FAR *lpVtbl;
    };

    

#ifdef COBJMACROS


#define IDataPortCollection_QueryInterface(This,riid,ppvObject)	\
    (This)->lpVtbl -> QueryInterface(This,riid,ppvObject)

#define IDataPortCollection_AddRef(This)	\
    (This)->lpVtbl -> AddRef(This)

#define IDataPortCollection_Release(This)	\
    (This)->lpVtbl -> Release(This)


#define IDataPortCollection_GetLabeledDataPort(This,guidLabelSystem,labelBuf,ppDataPort)	\
    (This)->lpVtbl -> GetLabeledDataPort(This,guidLabelSystem,labelBuf,ppDataPort)

#define IDataPortCollection_GetDataPortCount(This,pdwCount)	\
    (This)->lpVtbl -> GetDataPortCount(This,pdwCount)

#define IDataPortCollection_GetDataPort(This,index,ppDataPort)	\
    (This)->lpVtbl -> GetDataPort(This,index,ppDataPort)

#endif /* COBJMACROS */


#endif 	/* C style interface */



HRESULT STDMETHODCALLTYPE IDataPortCollection_GetLabeledDataPort_Proxy( 
    IDataPortCollection __RPC_FAR * This,
    REFGUID guidLabelSystem,
    WCHAR __RPC_FAR *labelBuf,
    IDataPort __RPC_FAR *__RPC_FAR *ppDataPort);


void __RPC_STUB IDataPortCollection_GetLabeledDataPort_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDataPortCollection_GetDataPortCount_Proxy( 
    IDataPortCollection __RPC_FAR * This,
    DWORD __RPC_FAR *pdwCount);


void __RPC_STUB IDataPortCollection_GetDataPortCount_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDataPortCollection_GetDataPort_Proxy( 
    IDataPortCollection __RPC_FAR * This,
    DWORD index,
    IDataPort __RPC_FAR *__RPC_FAR *ppDataPort);


void __RPC_STUB IDataPortCollection_GetDataPort_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);



#endif 	/* __IDataPortCollection_INTERFACE_DEFINED__ */


#ifndef __IMediaDriver_INTERFACE_DEFINED__
#define __IMediaDriver_INTERFACE_DEFINED__

/* interface IMediaDriver */
/* [unique][helpstring][local][uuid][object] */ 


EXTERN_C const IID IID_IMediaDriver;

#if defined(__cplusplus) && !defined(CINTERFACE)
    
    MIDL_INTERFACE("BB626EBF-5115-4e83-88CA-F9F53CA8F0E3")
    IMediaDriver : public IUnknown
    {
    public:
        virtual HRESULT STDMETHODCALLTYPE SelectRenderer( 
            WCHAR __RPC_FAR *pszRendererName) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetTrackBuffer( 
            void __RPC_FAR *__RPC_FAR *ppVirtualAddress,
            DWORD __RPC_FAR *pBufferSize) = 0;
        
    };
    
#else 	/* C style interface */

    typedef struct IMediaDriverVtbl
    {
        BEGIN_INTERFACE
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *QueryInterface )( 
            IMediaDriver __RPC_FAR * This,
            /* [in] */ REFIID riid,
            /* [iid_is][out] */ void __RPC_FAR *__RPC_FAR *ppvObject);
        
        ULONG ( STDMETHODCALLTYPE __RPC_FAR *AddRef )( 
            IMediaDriver __RPC_FAR * This);
        
        ULONG ( STDMETHODCALLTYPE __RPC_FAR *Release )( 
            IMediaDriver __RPC_FAR * This);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SelectRenderer )( 
            IMediaDriver __RPC_FAR * This,
            WCHAR __RPC_FAR *pszRendererName);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetTrackBuffer )( 
            IMediaDriver __RPC_FAR * This,
            void __RPC_FAR *__RPC_FAR *ppVirtualAddress,
            DWORD __RPC_FAR *pBufferSize);
        
        END_INTERFACE
    } IMediaDriverVtbl;

    interface IMediaDriver
    {
        CONST_VTBL struct IMediaDriverVtbl __RPC_FAR *lpVtbl;
    };

    

#ifdef COBJMACROS


#define IMediaDriver_QueryInterface(This,riid,ppvObject)	\
    (This)->lpVtbl -> QueryInterface(This,riid,ppvObject)

#define IMediaDriver_AddRef(This)	\
    (This)->lpVtbl -> AddRef(This)

#define IMediaDriver_Release(This)	\
    (This)->lpVtbl -> Release(This)


#define IMediaDriver_SelectRenderer(This,pszRendererName)	\
    (This)->lpVtbl -> SelectRenderer(This,pszRendererName)

#define IMediaDriver_GetTrackBuffer(This,ppVirtualAddress,pBufferSize)	\
    (This)->lpVtbl -> GetTrackBuffer(This,ppVirtualAddress,pBufferSize)

#endif /* COBJMACROS */


#endif 	/* C style interface */



HRESULT STDMETHODCALLTYPE IMediaDriver_SelectRenderer_Proxy( 
    IMediaDriver __RPC_FAR * This,
    WCHAR __RPC_FAR *pszRendererName);


void __RPC_STUB IMediaDriver_SelectRenderer_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IMediaDriver_GetTrackBuffer_Proxy( 
    IMediaDriver __RPC_FAR * This,
    void __RPC_FAR *__RPC_FAR *ppVirtualAddress,
    DWORD __RPC_FAR *pBufferSize);


void __RPC_STUB IMediaDriver_GetTrackBuffer_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);



#endif 	/* __IMediaDriver_INTERFACE_DEFINED__ */


#ifndef __IBitstreamProcessor_INTERFACE_DEFINED__
#define __IBitstreamProcessor_INTERFACE_DEFINED__

/* interface IBitstreamProcessor */
/* [unique][helpstring][local][uuid][object] */ 


EXTERN_C const IID IID_IBitstreamProcessor;

#if defined(__cplusplus) && !defined(CINTERFACE)
    
    MIDL_INTERFACE("99C99C6E-43E8-11d4-84C8-00C04F68EB0F")
    IBitstreamProcessor : public IUnknown
    {
    public:
        virtual HRESULT STDMETHODCALLTYPE Init( void) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE SetBitstreamType( 
            DWORD dwBitstreamType) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetLabeledDMAChannel( 
            REFGUID guidLabelSystem,
            WCHAR __RPC_FAR *labelBuf,
            IDMAChannel __RPC_FAR *__RPC_FAR *pDMAChannel) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetDMAChannelCount( 
            DWORD __RPC_FAR *pdwChannels) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetDMAChannel( 
            DWORD index,
            IDMAChannel __RPC_FAR *__RPC_FAR *ppChannel) = 0;
        
    };
    
#else 	/* C style interface */

    typedef struct IBitstreamProcessorVtbl
    {
        BEGIN_INTERFACE
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *QueryInterface )( 
            IBitstreamProcessor __RPC_FAR * This,
            /* [in] */ REFIID riid,
            /* [iid_is][out] */ void __RPC_FAR *__RPC_FAR *ppvObject);
        
        ULONG ( STDMETHODCALLTYPE __RPC_FAR *AddRef )( 
            IBitstreamProcessor __RPC_FAR * This);
        
        ULONG ( STDMETHODCALLTYPE __RPC_FAR *Release )( 
            IBitstreamProcessor __RPC_FAR * This);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Init )( 
            IBitstreamProcessor __RPC_FAR * This);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetBitstreamType )( 
            IBitstreamProcessor __RPC_FAR * This,
            DWORD dwBitstreamType);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetLabeledDMAChannel )( 
            IBitstreamProcessor __RPC_FAR * This,
            REFGUID guidLabelSystem,
            WCHAR __RPC_FAR *labelBuf,
            IDMAChannel __RPC_FAR *__RPC_FAR *pDMAChannel);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetDMAChannelCount )( 
            IBitstreamProcessor __RPC_FAR * This,
            DWORD __RPC_FAR *pdwChannels);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetDMAChannel )( 
            IBitstreamProcessor __RPC_FAR * This,
            DWORD index,
            IDMAChannel __RPC_FAR *__RPC_FAR *ppChannel);
        
        END_INTERFACE
    } IBitstreamProcessorVtbl;

    interface IBitstreamProcessor
    {
        CONST_VTBL struct IBitstreamProcessorVtbl __RPC_FAR *lpVtbl;
    };

    

#ifdef COBJMACROS


#define IBitstreamProcessor_QueryInterface(This,riid,ppvObject)	\
    (This)->lpVtbl -> QueryInterface(This,riid,ppvObject)

#define IBitstreamProcessor_AddRef(This)	\
    (This)->lpVtbl -> AddRef(This)

#define IBitstreamProcessor_Release(This)	\
    (This)->lpVtbl -> Release(This)


#define IBitstreamProcessor_Init(This)	\
    (This)->lpVtbl -> Init(This)

#define IBitstreamProcessor_SetBitstreamType(This,dwBitstreamType)	\
    (This)->lpVtbl -> SetBitstreamType(This,dwBitstreamType)

#define IBitstreamProcessor_GetLabeledDMAChannel(This,guidLabelSystem,labelBuf,pDMAChannel)	\
    (This)->lpVtbl -> GetLabeledDMAChannel(This,guidLabelSystem,labelBuf,pDMAChannel)

#define IBitstreamProcessor_GetDMAChannelCount(This,pdwChannels)	\
    (This)->lpVtbl -> GetDMAChannelCount(This,pdwChannels)

#define IBitstreamProcessor_GetDMAChannel(This,index,ppChannel)	\
    (This)->lpVtbl -> GetDMAChannel(This,index,ppChannel)

#endif /* COBJMACROS */


#endif 	/* C style interface */



HRESULT STDMETHODCALLTYPE IBitstreamProcessor_Init_Proxy( 
    IBitstreamProcessor __RPC_FAR * This);


void __RPC_STUB IBitstreamProcessor_Init_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IBitstreamProcessor_SetBitstreamType_Proxy( 
    IBitstreamProcessor __RPC_FAR * This,
    DWORD dwBitstreamType);


void __RPC_STUB IBitstreamProcessor_SetBitstreamType_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IBitstreamProcessor_GetLabeledDMAChannel_Proxy( 
    IBitstreamProcessor __RPC_FAR * This,
    REFGUID guidLabelSystem,
    WCHAR __RPC_FAR *labelBuf,
    IDMAChannel __RPC_FAR *__RPC_FAR *pDMAChannel);


void __RPC_STUB IBitstreamProcessor_GetLabeledDMAChannel_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IBitstreamProcessor_GetDMAChannelCount_Proxy( 
    IBitstreamProcessor __RPC_FAR * This,
    DWORD __RPC_FAR *pdwChannels);


void __RPC_STUB IBitstreamProcessor_GetDMAChannelCount_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IBitstreamProcessor_GetDMAChannel_Proxy( 
    IBitstreamProcessor __RPC_FAR * This,
    DWORD index,
    IDMAChannel __RPC_FAR *__RPC_FAR *ppChannel);


void __RPC_STUB IBitstreamProcessor_GetDMAChannel_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);



#endif 	/* __IBitstreamProcessor_INTERFACE_DEFINED__ */


#ifndef __IBitstreamProcessor2_INTERFACE_DEFINED__
#define __IBitstreamProcessor2_INTERFACE_DEFINED__

/* interface IBitstreamProcessor2 */
/* [unique][helpstring][local][uuid][object] */ 


EXTERN_C const IID IID_IBitstreamProcessor2;

#if defined(__cplusplus) && !defined(CINTERFACE)
    
    MIDL_INTERFACE("BA19F8F9-699E-4DFD-86DC-AB8B79DF78E1")
    IBitstreamProcessor2 : public IBitstreamProcessor
    {
    public:
        virtual HRESULT STDMETHODCALLTYPE GetLabeledDMAChannel2( 
            REFGUID guidLabelSystem,
            WCHAR __RPC_FAR *labelBuf,
            IDMAChannel2 __RPC_FAR *__RPC_FAR *pDmaChannel2) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetDMAChannel2Count( 
            DWORD __RPC_FAR *pdwChannels) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetDMAChannel2( 
            DWORD index,
            IDMAChannel2 __RPC_FAR *__RPC_FAR *ppChannel) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetTrackBuffer( 
            void __RPC_FAR *__RPC_FAR *ppVirtualAddress,
            DWORD __RPC_FAR *pBufferSize) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE ReleaseTrackBuffer( 
            void __RPC_FAR *pVirtualAddress) = 0;
        
    };
    
#else 	/* C style interface */

    typedef struct IBitstreamProcessor2Vtbl
    {
        BEGIN_INTERFACE
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *QueryInterface )( 
            IBitstreamProcessor2 __RPC_FAR * This,
            /* [in] */ REFIID riid,
            /* [iid_is][out] */ void __RPC_FAR *__RPC_FAR *ppvObject);
        
        ULONG ( STDMETHODCALLTYPE __RPC_FAR *AddRef )( 
            IBitstreamProcessor2 __RPC_FAR * This);
        
        ULONG ( STDMETHODCALLTYPE __RPC_FAR *Release )( 
            IBitstreamProcessor2 __RPC_FAR * This);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Init )( 
            IBitstreamProcessor2 __RPC_FAR * This);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetBitstreamType )( 
            IBitstreamProcessor2 __RPC_FAR * This,
            DWORD dwBitstreamType);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetLabeledDMAChannel )( 
            IBitstreamProcessor2 __RPC_FAR * This,
            REFGUID guidLabelSystem,
            WCHAR __RPC_FAR *labelBuf,
            IDMAChannel __RPC_FAR *__RPC_FAR *pDMAChannel);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetDMAChannelCount )( 
            IBitstreamProcessor2 __RPC_FAR * This,
            DWORD __RPC_FAR *pdwChannels);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetDMAChannel )( 
            IBitstreamProcessor2 __RPC_FAR * This,
            DWORD index,
            IDMAChannel __RPC_FAR *__RPC_FAR *ppChannel);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetLabeledDMAChannel2 )( 
            IBitstreamProcessor2 __RPC_FAR * This,
            REFGUID guidLabelSystem,
            WCHAR __RPC_FAR *labelBuf,
            IDMAChannel2 __RPC_FAR *__RPC_FAR *pDmaChannel2);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetDMAChannel2Count )( 
            IBitstreamProcessor2 __RPC_FAR * This,
            DWORD __RPC_FAR *pdwChannels);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetDMAChannel2 )( 
            IBitstreamProcessor2 __RPC_FAR * This,
            DWORD index,
            IDMAChannel2 __RPC_FAR *__RPC_FAR *ppChannel);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetTrackBuffer )( 
            IBitstreamProcessor2 __RPC_FAR * This,
            void __RPC_FAR *__RPC_FAR *ppVirtualAddress,
            DWORD __RPC_FAR *pBufferSize);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *ReleaseTrackBuffer )( 
            IBitstreamProcessor2 __RPC_FAR * This,
            void __RPC_FAR *pVirtualAddress);
        
        END_INTERFACE
    } IBitstreamProcessor2Vtbl;

    interface IBitstreamProcessor2
    {
        CONST_VTBL struct IBitstreamProcessor2Vtbl __RPC_FAR *lpVtbl;
    };

    

#ifdef COBJMACROS


#define IBitstreamProcessor2_QueryInterface(This,riid,ppvObject)	\
    (This)->lpVtbl -> QueryInterface(This,riid,ppvObject)

#define IBitstreamProcessor2_AddRef(This)	\
    (This)->lpVtbl -> AddRef(This)

#define IBitstreamProcessor2_Release(This)	\
    (This)->lpVtbl -> Release(This)


#define IBitstreamProcessor2_Init(This)	\
    (This)->lpVtbl -> Init(This)

#define IBitstreamProcessor2_SetBitstreamType(This,dwBitstreamType)	\
    (This)->lpVtbl -> SetBitstreamType(This,dwBitstreamType)

#define IBitstreamProcessor2_GetLabeledDMAChannel(This,guidLabelSystem,labelBuf,pDMAChannel)	\
    (This)->lpVtbl -> GetLabeledDMAChannel(This,guidLabelSystem,labelBuf,pDMAChannel)

#define IBitstreamProcessor2_GetDMAChannelCount(This,pdwChannels)	\
    (This)->lpVtbl -> GetDMAChannelCount(This,pdwChannels)

#define IBitstreamProcessor2_GetDMAChannel(This,index,ppChannel)	\
    (This)->lpVtbl -> GetDMAChannel(This,index,ppChannel)


#define IBitstreamProcessor2_GetLabeledDMAChannel2(This,guidLabelSystem,labelBuf,pDmaChannel2)	\
    (This)->lpVtbl -> GetLabeledDMAChannel2(This,guidLabelSystem,labelBuf,pDmaChannel2)

#define IBitstreamProcessor2_GetDMAChannel2Count(This,pdwChannels)	\
    (This)->lpVtbl -> GetDMAChannel2Count(This,pdwChannels)

#define IBitstreamProcessor2_GetDMAChannel2(This,index,ppChannel)	\
    (This)->lpVtbl -> GetDMAChannel2(This,index,ppChannel)

#define IBitstreamProcessor2_GetTrackBuffer(This,ppVirtualAddress,pBufferSize)	\
    (This)->lpVtbl -> GetTrackBuffer(This,ppVirtualAddress,pBufferSize)

#define IBitstreamProcessor2_ReleaseTrackBuffer(This,pVirtualAddress)	\
    (This)->lpVtbl -> ReleaseTrackBuffer(This,pVirtualAddress)

#endif /* COBJMACROS */


#endif 	/* C style interface */



HRESULT STDMETHODCALLTYPE IBitstreamProcessor2_GetLabeledDMAChannel2_Proxy( 
    IBitstreamProcessor2 __RPC_FAR * This,
    REFGUID guidLabelSystem,
    WCHAR __RPC_FAR *labelBuf,
    IDMAChannel2 __RPC_FAR *__RPC_FAR *pDmaChannel2);


void __RPC_STUB IBitstreamProcessor2_GetLabeledDMAChannel2_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IBitstreamProcessor2_GetDMAChannel2Count_Proxy( 
    IBitstreamProcessor2 __RPC_FAR * This,
    DWORD __RPC_FAR *pdwChannels);


void __RPC_STUB IBitstreamProcessor2_GetDMAChannel2Count_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IBitstreamProcessor2_GetDMAChannel2_Proxy( 
    IBitstreamProcessor2 __RPC_FAR * This,
    DWORD index,
    IDMAChannel2 __RPC_FAR *__RPC_FAR *ppChannel);


void __RPC_STUB IBitstreamProcessor2_GetDMAChannel2_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IBitstreamProcessor2_GetTrackBuffer_Proxy( 
    IBitstreamProcessor2 __RPC_FAR * This,
    void __RPC_FAR *__RPC_FAR *ppVirtualAddress,
    DWORD __RPC_FAR *pBufferSize);


void __RPC_STUB IBitstreamProcessor2_GetTrackBuffer_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IBitstreamProcessor2_ReleaseTrackBuffer_Proxy( 
    IBitstreamProcessor2 __RPC_FAR * This,
    void __RPC_FAR *pVirtualAddress);


void __RPC_STUB IBitstreamProcessor2_ReleaseTrackBuffer_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);



#endif 	/* __IBitstreamProcessor2_INTERFACE_DEFINED__ */


/* interface __MIDL_itf_dvddrvr_0013 */
/* [local] */ 

typedef /* [public][public] */ 
enum __MIDL___MIDL_itf_dvddrvr_0013_0001
    {	HIGHLIGHT_SELECT	= 1,
	UNHIGHLIGHT	= HIGHLIGHT_SELECT + 1,
	ACTIVATE_BUTTON	= UNHIGHLIGHT + 1,
	ACTIVATE_SELECTED	= ACTIVATE_BUTTON + 1,
	SELECT_AUTO_ACTIVATED	= ACTIVATE_SELECTED + 1
    }	EHighlightAction;

typedef /* [public][public][public] */ 
enum __MIDL___MIDL_itf_dvddrvr_0013_0002
    {	DVD_NAV_PACK_EVENT	= 0,
	DVD_HIGHLIGHT_EVENT	= DVD_NAV_PACK_EVENT + 1,
	DVD_PLAYBACK_EVENT	= DVD_HIGHLIGHT_EVENT + 1,
	DVD_CC_DATA_EVENT	= DVD_PLAYBACK_EVENT + 1
    }	EDVDSyncEventType;

typedef /* [public][public] */ 
enum __MIDL___MIDL_itf_dvddrvr_0013_0003
    {	DVD_AUDIO_TYPE_AC3	= 2,
	DVD_AUDIO_TYPE_MPEG	= DVD_AUDIO_TYPE_AC3 + 1,
	DVD_AUDIO_TYPE_LPCM	= DVD_AUDIO_TYPE_MPEG + 1,
	DVD_AUDIO_TYPE_DTS	= DVD_AUDIO_TYPE_LPCM + 1,
	DVD_AUDIO_TYPE_SDDS	= DVD_AUDIO_TYPE_DTS + 1,
	DVD_AUDIO_TYPE_MPEG2_EXT	= DVD_AUDIO_TYPE_SDDS + 1
    }	EDVDAudioStreamType;

typedef /* [public] */ 
enum __MIDL___MIDL_itf_dvddrvr_0013_0004
    {	DVD_LPCM_16	= 0,
	DVD_LPCM_20	= DVD_LPCM_16 + 1,
	DVD_LPCM_24	= DVD_LPCM_20 + 1
    }	EDVDLpcmQuantization;

typedef /* [public] */ 
enum __MIDL___MIDL_itf_dvddrvr_0013_0005
    {	DVD_AUDIO_FREQ_48KHZ	= 0,
	DVD_AUDIO_FREQ_96KHZ	= DVD_AUDIO_FREQ_48KHZ + 1
    }	EDVDAudioFreq;

typedef /* [public][public][public] */ 
enum __MIDL___MIDL_itf_dvddrvr_0013_0006
    {	DVD_DISPLAY_ASPECT_4x3	= 0,
	DVD_DISPLAY_ASPECT_16x9	= 0x3,
	DVD_USE_MPEG2_ASPECT	= 0x1
    }	EDVDDisplayAspectRatio;

typedef /* [public][public] */ 
enum __MIDL___MIDL_itf_dvddrvr_0013_0007
    {	DVD_ASPECT_RATIO_MODE_LETTERBOX	= 0,
	DVD_ASPECT_RATIO_MODE_PANSCAN	= DVD_ASPECT_RATIO_MODE_LETTERBOX + 1
    }	EDVDAspectRatioMode;

#ifndef _DVD_SCANCAPS_DEFINED_
#define _DVD_SCANCAPS_DEFINED_
#define DVD_SCANCAP_FORWARD_SCAN		0x1
#define DVD_SCANCAP_FORWARD_SLOW		0x2
#define DVD_SCANCAP_FORWARD_SINGLE	0x4
#define DVD_SCANCAP_BACKWARD_SCAN	0x8
#define DVD_SCANCAP_BACKWARD_SLOW	0x10
#define DVD_SCANCAP_BACKWARD_SINGLE	0x20
#endif
#define DVD_AUDIOCAP_AC3				0x4000
#define DVD_AUDIOCAP_MPEG			0x1000
#define DVD_AUDIOCAP_DTS				0x0800
#define DVD_AUDIOCAP_SDDS			0x0400
#define DVD_AUDIOCAP_LPCM_KARAOKE	0x0080
#define DVD_AUDIOCAP_AC3_KARAOKE		0x0040
#define DVD_AUDIOCAP_MPEG_KARAOKE	0x0010
#define DVD_AUDIOCAP_DTS_KARAOKE		0x0008
#define DVD_AUDIOCAP_SDDS_KARAOKE	0x0004


extern RPC_IF_HANDLE __MIDL_itf_dvddrvr_0013_v0_0_c_ifspec;
extern RPC_IF_HANDLE __MIDL_itf_dvddrvr_0013_v0_0_s_ifspec;

#ifndef __IDVDRenderer_INTERFACE_DEFINED__
#define __IDVDRenderer_INTERFACE_DEFINED__

/* interface IDVDRenderer */
/* [unique][helpstring][local][uuid][object] */ 


EXTERN_C const IID IID_IDVDRenderer;

#if defined(__cplusplus) && !defined(CINTERFACE)
    
    MIDL_INTERFACE("99C99C73-43E8-11d4-84C8-00C04F68EB0F")
    IDVDRenderer : public IUnknown
    {
    public:
        virtual HRESULT STDMETHODCALLTYPE RegisterSyncEvent( 
            EDVDSyncEventType eType,
            HANDLE h,
            void __RPC_FAR *pDataLock,
            DWORD dwMaxDataSize,
            void __RPC_FAR *pEventData) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE Play( void) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE Abort( void) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE Pause( 
            BOOL bOn) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE SetAudioStreamType( 
            EDVDAudioStreamType dwSelectedDecoder) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE SetAudioStreamNumber( 
            int iDecodingNumber) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE SetSubpictureStreamNumber( 
            int iDecodingNumber,
            BOOL bDisplay) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE SetPalette( 
            DWORD __RPC_FAR *pPalette) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE Highlight( 
            BYTE buttonNumber,
            EHighlightAction action,
            BOOL bRelativeMode) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetHighlightedButton( 
            BYTE __RPC_FAR *buttonNumber) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE SetContentAspectRatio( 
            EDVDDisplayAspectRatio enumDisplayAspectRatio) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE SetDisplayAspectRatio( 
            EDVDDisplayAspectRatio enumDisplayAspectRatio) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE SetAspectRatioMode( 
            EDVDAspectRatioMode enumAspectRatioMode) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE Scan( 
            BOOL bForward,
            double dRate,
            double __RPC_FAR *dwActual,
            DWORD __RPC_FAR *bVobuSkip) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE Slow( 
            BOOL bForward,
            double dRate,
            double __RPC_FAR *dwActual) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE Step( 
            BOOL bForward) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetScanCaps( 
            DWORD __RPC_FAR *pdwCaps) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetAudioCaps( 
            DWORD __RPC_FAR *pdwCaps) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE UnregisterSyncEvent( 
            EDVDSyncEventType eType,
            HANDLE h) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE SetAPS( 
            DWORD apsType,
            DWORD __RPC_FAR *pdwCookie) = 0;
        
    };
    
#else 	/* C style interface */

    typedef struct IDVDRendererVtbl
    {
        BEGIN_INTERFACE
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *QueryInterface )( 
            IDVDRenderer __RPC_FAR * This,
            /* [in] */ REFIID riid,
            /* [iid_is][out] */ void __RPC_FAR *__RPC_FAR *ppvObject);
        
        ULONG ( STDMETHODCALLTYPE __RPC_FAR *AddRef )( 
            IDVDRenderer __RPC_FAR * This);
        
        ULONG ( STDMETHODCALLTYPE __RPC_FAR *Release )( 
            IDVDRenderer __RPC_FAR * This);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *RegisterSyncEvent )( 
            IDVDRenderer __RPC_FAR * This,
            EDVDSyncEventType eType,
            HANDLE h,
            void __RPC_FAR *pDataLock,
            DWORD dwMaxDataSize,
            void __RPC_FAR *pEventData);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Play )( 
            IDVDRenderer __RPC_FAR * This);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Abort )( 
            IDVDRenderer __RPC_FAR * This);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Pause )( 
            IDVDRenderer __RPC_FAR * This,
            BOOL bOn);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetAudioStreamType )( 
            IDVDRenderer __RPC_FAR * This,
            EDVDAudioStreamType dwSelectedDecoder);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetAudioStreamNumber )( 
            IDVDRenderer __RPC_FAR * This,
            int iDecodingNumber);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetSubpictureStreamNumber )( 
            IDVDRenderer __RPC_FAR * This,
            int iDecodingNumber,
            BOOL bDisplay);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetPalette )( 
            IDVDRenderer __RPC_FAR * This,
            DWORD __RPC_FAR *pPalette);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Highlight )( 
            IDVDRenderer __RPC_FAR * This,
            BYTE buttonNumber,
            EHighlightAction action,
            BOOL bRelativeMode);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetHighlightedButton )( 
            IDVDRenderer __RPC_FAR * This,
            BYTE __RPC_FAR *buttonNumber);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetContentAspectRatio )( 
            IDVDRenderer __RPC_FAR * This,
            EDVDDisplayAspectRatio enumDisplayAspectRatio);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetDisplayAspectRatio )( 
            IDVDRenderer __RPC_FAR * This,
            EDVDDisplayAspectRatio enumDisplayAspectRatio);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetAspectRatioMode )( 
            IDVDRenderer __RPC_FAR * This,
            EDVDAspectRatioMode enumAspectRatioMode);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Scan )( 
            IDVDRenderer __RPC_FAR * This,
            BOOL bForward,
            double dRate,
            double __RPC_FAR *dwActual,
            DWORD __RPC_FAR *bVobuSkip);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Slow )( 
            IDVDRenderer __RPC_FAR * This,
            BOOL bForward,
            double dRate,
            double __RPC_FAR *dwActual);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Step )( 
            IDVDRenderer __RPC_FAR * This,
            BOOL bForward);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetScanCaps )( 
            IDVDRenderer __RPC_FAR * This,
            DWORD __RPC_FAR *pdwCaps);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetAudioCaps )( 
            IDVDRenderer __RPC_FAR * This,
            DWORD __RPC_FAR *pdwCaps);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *UnregisterSyncEvent )( 
            IDVDRenderer __RPC_FAR * This,
            EDVDSyncEventType eType,
            HANDLE h);
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetAPS )( 
            IDVDRenderer __RPC_FAR * This,
            DWORD apsType,
            DWORD __RPC_FAR *pdwCookie);
        
        END_INTERFACE
    } IDVDRendererVtbl;

    interface IDVDRenderer
    {
        CONST_VTBL struct IDVDRendererVtbl __RPC_FAR *lpVtbl;
    };

    

#ifdef COBJMACROS


#define IDVDRenderer_QueryInterface(This,riid,ppvObject)	\
    (This)->lpVtbl -> QueryInterface(This,riid,ppvObject)

#define IDVDRenderer_AddRef(This)	\
    (This)->lpVtbl -> AddRef(This)

#define IDVDRenderer_Release(This)	\
    (This)->lpVtbl -> Release(This)


#define IDVDRenderer_RegisterSyncEvent(This,eType,h,pDataLock,dwMaxDataSize,pEventData)	\
    (This)->lpVtbl -> RegisterSyncEvent(This,eType,h,pDataLock,dwMaxDataSize,pEventData)

#define IDVDRenderer_Play(This)	\
    (This)->lpVtbl -> Play(This)

#define IDVDRenderer_Abort(This)	\
    (This)->lpVtbl -> Abort(This)

#define IDVDRenderer_Pause(This,bOn)	\
    (This)->lpVtbl -> Pause(This,bOn)

#define IDVDRenderer_SetAudioStreamType(This,dwSelectedDecoder)	\
    (This)->lpVtbl -> SetAudioStreamType(This,dwSelectedDecoder)

#define IDVDRenderer_SetAudioStreamNumber(This,iDecodingNumber)	\
    (This)->lpVtbl -> SetAudioStreamNumber(This,iDecodingNumber)

#define IDVDRenderer_SetSubpictureStreamNumber(This,iDecodingNumber,bDisplay)	\
    (This)->lpVtbl -> SetSubpictureStreamNumber(This,iDecodingNumber,bDisplay)

#define IDVDRenderer_SetPalette(This,pPalette)	\
    (This)->lpVtbl -> SetPalette(This,pPalette)

#define IDVDRenderer_Highlight(This,buttonNumber,action,bRelativeMode)	\
    (This)->lpVtbl -> Highlight(This,buttonNumber,action,bRelativeMode)

#define IDVDRenderer_GetHighlightedButton(This,buttonNumber)	\
    (This)->lpVtbl -> GetHighlightedButton(This,buttonNumber)

#define IDVDRenderer_SetContentAspectRatio(This,enumDisplayAspectRatio)	\
    (This)->lpVtbl -> SetContentAspectRatio(This,enumDisplayAspectRatio)

#define IDVDRenderer_SetDisplayAspectRatio(This,enumDisplayAspectRatio)	\
    (This)->lpVtbl -> SetDisplayAspectRatio(This,enumDisplayAspectRatio)

#define IDVDRenderer_SetAspectRatioMode(This,enumAspectRatioMode)	\
    (This)->lpVtbl -> SetAspectRatioMode(This,enumAspectRatioMode)

#define IDVDRenderer_Scan(This,bForward,dRate,dwActual,bVobuSkip)	\
    (This)->lpVtbl -> Scan(This,bForward,dRate,dwActual,bVobuSkip)

#define IDVDRenderer_Slow(This,bForward,dRate,dwActual)	\
    (This)->lpVtbl -> Slow(This,bForward,dRate,dwActual)

#define IDVDRenderer_Step(This,bForward)	\
    (This)->lpVtbl -> Step(This,bForward)

#define IDVDRenderer_GetScanCaps(This,pdwCaps)	\
    (This)->lpVtbl -> GetScanCaps(This,pdwCaps)

#define IDVDRenderer_GetAudioCaps(This,pdwCaps)	\
    (This)->lpVtbl -> GetAudioCaps(This,pdwCaps)

#define IDVDRenderer_UnregisterSyncEvent(This,eType,h)	\
    (This)->lpVtbl -> UnregisterSyncEvent(This,eType,h)

#define IDVDRenderer_SetAPS(This,apsType,pdwCookie)	\
    (This)->lpVtbl -> SetAPS(This,apsType,pdwCookie)

#endif /* COBJMACROS */


#endif 	/* C style interface */



HRESULT STDMETHODCALLTYPE IDVDRenderer_RegisterSyncEvent_Proxy( 
    IDVDRenderer __RPC_FAR * This,
    EDVDSyncEventType eType,
    HANDLE h,
    void __RPC_FAR *pDataLock,
    DWORD dwMaxDataSize,
    void __RPC_FAR *pEventData);


void __RPC_STUB IDVDRenderer_RegisterSyncEvent_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDRenderer_Play_Proxy( 
    IDVDRenderer __RPC_FAR * This);


void __RPC_STUB IDVDRenderer_Play_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDRenderer_Abort_Proxy( 
    IDVDRenderer __RPC_FAR * This);


void __RPC_STUB IDVDRenderer_Abort_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDRenderer_Pause_Proxy( 
    IDVDRenderer __RPC_FAR * This,
    BOOL bOn);


void __RPC_STUB IDVDRenderer_Pause_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDRenderer_SetAudioStreamType_Proxy( 
    IDVDRenderer __RPC_FAR * This,
    EDVDAudioStreamType dwSelectedDecoder);


void __RPC_STUB IDVDRenderer_SetAudioStreamType_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDRenderer_SetAudioStreamNumber_Proxy( 
    IDVDRenderer __RPC_FAR * This,
    int iDecodingNumber);


void __RPC_STUB IDVDRenderer_SetAudioStreamNumber_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDRenderer_SetSubpictureStreamNumber_Proxy( 
    IDVDRenderer __RPC_FAR * This,
    int iDecodingNumber,
    BOOL bDisplay);


void __RPC_STUB IDVDRenderer_SetSubpictureStreamNumber_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDRenderer_SetPalette_Proxy( 
    IDVDRenderer __RPC_FAR * This,
    DWORD __RPC_FAR *pPalette);


void __RPC_STUB IDVDRenderer_SetPalette_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDRenderer_Highlight_Proxy( 
    IDVDRenderer __RPC_FAR * This,
    BYTE buttonNumber,
    EHighlightAction action,
    BOOL bRelativeMode);


void __RPC_STUB IDVDRenderer_Highlight_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDRenderer_GetHighlightedButton_Proxy( 
    IDVDRenderer __RPC_FAR * This,
    BYTE __RPC_FAR *buttonNumber);


void __RPC_STUB IDVDRenderer_GetHighlightedButton_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDRenderer_SetContentAspectRatio_Proxy( 
    IDVDRenderer __RPC_FAR * This,
    EDVDDisplayAspectRatio enumDisplayAspectRatio);


void __RPC_STUB IDVDRenderer_SetContentAspectRatio_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDRenderer_SetDisplayAspectRatio_Proxy( 
    IDVDRenderer __RPC_FAR * This,
    EDVDDisplayAspectRatio enumDisplayAspectRatio);


void __RPC_STUB IDVDRenderer_SetDisplayAspectRatio_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDRenderer_SetAspectRatioMode_Proxy( 
    IDVDRenderer __RPC_FAR * This,
    EDVDAspectRatioMode enumAspectRatioMode);


void __RPC_STUB IDVDRenderer_SetAspectRatioMode_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDRenderer_Scan_Proxy( 
    IDVDRenderer __RPC_FAR * This,
    BOOL bForward,
    double dRate,
    double __RPC_FAR *dwActual,
    DWORD __RPC_FAR *bVobuSkip);


void __RPC_STUB IDVDRenderer_Scan_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDRenderer_Slow_Proxy( 
    IDVDRenderer __RPC_FAR * This,
    BOOL bForward,
    double dRate,
    double __RPC_FAR *dwActual);


void __RPC_STUB IDVDRenderer_Slow_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDRenderer_Step_Proxy( 
    IDVDRenderer __RPC_FAR * This,
    BOOL bForward);


void __RPC_STUB IDVDRenderer_Step_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDRenderer_GetScanCaps_Proxy( 
    IDVDRenderer __RPC_FAR * This,
    DWORD __RPC_FAR *pdwCaps);


void __RPC_STUB IDVDRenderer_GetScanCaps_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDRenderer_GetAudioCaps_Proxy( 
    IDVDRenderer __RPC_FAR * This,
    DWORD __RPC_FAR *pdwCaps);


void __RPC_STUB IDVDRenderer_GetAudioCaps_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDRenderer_UnregisterSyncEvent_Proxy( 
    IDVDRenderer __RPC_FAR * This,
    EDVDSyncEventType eType,
    HANDLE h);


void __RPC_STUB IDVDRenderer_UnregisterSyncEvent_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE IDVDRenderer_SetAPS_Proxy( 
    IDVDRenderer __RPC_FAR * This,
    DWORD apsType,
    DWORD __RPC_FAR *pdwCookie);


void __RPC_STUB IDVDRenderer_SetAPS_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);



#endif 	/* __IDVDRenderer_INTERFACE_DEFINED__ */



#ifndef __MediaDriver_LIBRARY_DEFINED__
#define __MediaDriver_LIBRARY_DEFINED__

/* library MediaDriver */
/* [helpstring][version][uuid] */ 


EXTERN_C const IID LIBID_MediaDriver;

EXTERN_C const CLSID CLSID_DataPort;

#ifdef __cplusplus

class DECLSPEC_UUID("99C99C70-43E8-11d4-84C8-00C04F68EB0F")
DataPort;
#endif

EXTERN_C const CLSID CLSID_MediaDriver;

#ifdef __cplusplus

class DECLSPEC_UUID("99C99C72-43E8-11d4-84C8-00C04F68EB0F")
MediaDriver;
#endif
#endif /* __MediaDriver_LIBRARY_DEFINED__ */

/* Additional Prototypes for ALL interfaces */

/* end of Additional Prototypes */

#ifdef __cplusplus
}
#endif

#endif


